<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 2.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_JEXEC') or die();
require_once JPATH_ROOT. DIRECTORY_SEPARATOR .'components/com_cobalt/library/php/fields/cobaltfield.php';


class JFormFieldCAmazon extends CFormField
{


	public function getInput()
	{

		return $this->_display_input();
	}

	public function onJSValidate()
	{
	}

	public function validate($value, $record, $type, $section)
	{
		return parent::validate($value, $record, $type, $section);
	}

	public function onPrepareSave($value, $record, $type, $section)
	{
		if ($value)
		{
			return $value;
		}
	}

	public function onRenderFull($record, $type, $section)
	{
		if (!$this->value)
			return;
			jimport( 'joomla.filesystem.folder' );
			$this->cachepath = "cache/cobalt-field-amazon";
			if (!JFolder::exists(JPATH_SITE. DIRECTORY_SEPARATOR .$this->cachepath)) {
				if (! JFolder::create(JPATH_SITE. DIRECTORY_SEPARATOR .$this->cachepath)) {
					return JError::raiseError(-1, JText::_('Unable to create target folder'));
				}
			}
			// Get plugin settings
			$this->associate_tag = $this->params->get('params.assid', 0);
			$this->region = $this->params->get('params.country');
			$this->public_key = $this->params->get('params.public_key', 0);
			$this->private_key = $this->params->get('params.private_key', 0);
			$this->image = $this->params->get('params.image', 0);
			$this->buy_now = $this->params->get('params.buy_now', 0);
			$this->costumerreviews = $this->params->get('params.costumerreviews', 0);
			$this->similar = $this->params->get('params.similar', 0);
			$this->debug = $this->params->get('params.debug', 0);
			$this->cache = $this->params->get('params.cache', 3600);
			
			if(empty($this->value['asin'])) { 
				return;
			} else {
				if ($this->value['mode'] == "lookup") {
					$parameters = array("Operation"=>"ItemLookup", "ItemId"=>$this->value['asin'], "ResponseGroup"=>"Large");
					$this->amazon_request = $this->_aws_signed_request($this->region, $parameters, $this->public_key, $this->private_key, $this->associate_tag);
				}
			if ($this->value['mode'] == "search") {
				$parameters = array("Operation"=>"ItemSearch", "Keywords"=>$this->value['asin'], "SearchIndex"=>$this->value['category'], "ResponseGroup"=>"Large");
				$this->amazon_request = $this->_aws_signed_request($this->region, $parameters, $this->public_key, $this->private_key, $this->associate_tag);
			}
		// Get xml from cache, if xml isn't cached or is to old get new from Amazon
		$cachedatei = JPATH_SITE. DIRECTORY_SEPARATOR .$this->cachepath. DIRECTORY_SEPARATOR ."rec".$record->id."id".$this->id.$this->value['asin'].".xml";
		$cachezeit  = time()-$this->cache;
		//Get data from Amazon	
		if (file_exists($cachedatei)){
                if (filemtime($cachedatei)<$cachezeit){
                      $daten = file_get_contents($this->amazon_request);
                      file_put_contents($cachedatei, $daten);
                }else {$daten = file_get_contents($cachedatei); }
		}else {$daten = file_get_contents($this->amazon_request);
              file_put_contents($cachedatei, $daten);
             }
		$this->xml = simplexml_load_string($daten);
		}
			return $this->_display_output('full', $record, $type, $section);			

		return;
	
	}

	public function onRenderList($record, $type, $section)
	{
		
		//return $this->_display_output('list', $record, $type, $section);
		
	}
	
	function _getSimiliars($asin, $public_key, $private_key, $associate_tag, $region, $image, $debug, $cache) {
	jimport( 'joomla.filesystem.folder' );
	$cachepath = "cache/cobalt-field-amazon";
	if (!JFolder::exists(JPATH_SITE. DIRECTORY_SEPARATOR .$cachepath)) {
		if (! JFolder::create(JPATH_SITE. DIRECTORY_SEPARATOR .$cachepath)) {
			return JError::raiseError(-1, JText::_('Unable to create target folder'));
		}
	}	
	$params = array("Operation"=>"SimilarityLookup", "ItemId"=>$asin, "ResponseGroup"=>"Medium,Images");
	$request2 = $this->_aws_signed_request($region, $params, $public_key, $private_key, $associate_tag);
	// Get xml from cache, if xml isn't cached or is to old get new from Amazon
		$cachedatei = JPATH_SITE. DIRECTORY_SEPARATOR .$this->cachepath. DIRECTORY_SEPARATOR ."similar-".$asin.".xml";
		$cachezeit  = time()-$this->cache;

        if (file_exists($cachedatei)){
                if (filemtime($cachedatei)<$cachezeit){
                      $daten = file_get_contents($request2);
                      file_put_contents($cachedatei, $daten);
                }else {$daten = file_get_contents($cachedatei); }
		}else {$daten = file_get_contents($request2);
              file_put_contents($cachedatei, $daten);
             } 
		$xml2 = simplexml_load_string($daten);	
				
	if ($debug==1) {
		echo '<p>Processing Time:'.$xml2->OperationRequest->RequestProcessingTime.' seconds</p>';
		echo 'Request URL: <a href="'.$request2.'" target="_blank">'.$request2.'</a><pre>';
		print_r($xml2);
		echo '</pre>';
		
	} //end if ($debug)		
$out = '';
// Report Errors 
if(isset($xml2->Items->Request->Errors->Error->Code)){
	echo "<p class='error'>Error: ".$xml2->Items->Request->Errors->Error->Code."<br/>Message: ".$xml2->Items->Request->Errors->Error->Message."</p>";
	return $out;
}
	
			if(isset($xml2->Items)) {
				$out .= "<h4>".JText::_('Similar Products')."</h4>";
				$n=0;
				foreach($xml2->Items->Item as $similar){
					$n = ($n%2) ? $n : $n%2;
					$out .= "<div class='cat-list-row".$n."' style='overflow:hidden'>";
					$sim_author_out = '';
					$sim_artist_out = '';				
					if (!empty($similar->ItemAttributes->Author)) {	
						foreach($similar->ItemAttributes->Author as $author) {
							$sim_author_out .= $author."&nbsp;";
						}								
					}
					if (!empty($similar->ItemAttributes->Artist)) {	
							$sim_artist_out .= $similar->ItemAttributes->Artist."&nbsp;";	
					}

				if (!empty($similar->SmallImage->URL) && !empty($similar->LargeImage->URL)) {
					if($image == 1) {
						$out .= "<img src='".$similar->SmallImage->URL."' alt='".str_replace("'", "", $similar->ItemAttributes->Title)." :: ".$sim_author_out.$sim_artist_out."' style='float:left; padding-right:5px;' />\n"; 
					}
					if($image == 2) {
						$out .= "<a class='jcepopup' target='_blank' title='".str_replace("'", "", $similar->ItemAttributes->Title)." :: ".$sim_author_out.$sim_artist_out."' href='".$similar->LargeImage->URL."'><img alt='".str_replace("'", "", $similar->ItemAttributes->Title)." :: ".$sim_author_out.$sim_artist_out."' src='".$similar->SmallImage->URL."' style='float:left; padding-right:5px;' /></a>\n";
					}
					if($image == 3) {
						$out .= "<a rel='rokbox[]' title='".str_replace("'", "", $similar->ItemAttributes->Title)." :: ".$sim_author_out.$sim_artist_out."' href='".$similar->LargeImage->URL."'><img src='".$similar->SmallImage->URL."' alt='".str_replace("'", "", $similar->ItemAttributes->Title)." :: ".$sim_author_out.$sim_artist_out."' style='float:left; padding-right:5px;' /></a>\n"; 
					}
				}
					$out .= "<b><a href='".$similar->DetailPageURL."' target='_blank' class='icon-external-link'> ".$similar->ItemAttributes->Title."</a></b>";
					
					if (!empty($sim_author_out)) {	
						$out .= "<br/><b><i>".$sim_author_out."</i></b>";	
					}
					if (!empty($sim_artist_out)) {	
						$out .= "<br/><b><i>".$sim_artist_out."</i></b>";	
					}
					if (!empty($similar->ItemAttributes->ListPrice->FormattedPrice)) {
						$out .= "<br/>". JText::_('Price').": ".$similar->ItemAttributes->ListPrice->FormattedPrice . "";
					}
					if (!empty($similar->SalesRank)) {
					 $out .=  "<br/>". JText::_('SalesRank').": " . number_format((int)$similar->SalesRank, '0', '', '.') . "";
					}	
					$out .= "</div>";
					$n++;
				}	
				$out .= "<br style='clear:both' />";
				
		} // end if(!empty($similars)
		
	return $out;
	}
	
	function _aws_signed_request($region, $parameters, $public_key, $private_key, $associate_tag=NULL, $version='2011-08-01')
{
    /*
    Copyright (c) 2009-2012 Ulrich Mierendorff

    Permission is hereby granted, free of charge, to any person obtaining a
    copy of this software and associated documentation files (the "Software"),
    to deal in the Software without restriction, including without limitation
    the rights to use, copy, modify, merge, publish, distribute, sublicense,
    and/or sell copies of the Software, and to permit persons to whom the
    Software is furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in
    all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
    THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.
    */
    
    /*
    Parameters:
        $region - the Amazon(r) region (ca,com,co.uk,de,fr,co.jp)
        $parameters - an array of parameters, eg. array("Operation"=>"ItemLookup",
                        "ItemId"=>"B000X9FLKM", "ResponseGroup"=>"Small")
        $public_key - your "Access Key ID"
        $private_key - your "Secret Access Key"
        $version (optional)
    */
    
    // some paramters
    $method = 'GET';
    $host = 'webservices.amazon.'.$region;
    $uri = '/onca/xml';
    
    // additional parameters
    $parameters['Service'] = 'AWSECommerceService';
    $parameters['AWSAccessKeyId'] = $public_key;
    // GMT timestamp
    $parameters['Timestamp'] = gmdate('Y-m-d\TH:i:s\Z');
    // API version
    $parameters['Version'] = $version;
    if ($associate_tag !== NULL) {
        $parameters['AssociateTag'] = $associate_tag;
    }
    
    // sort the parameters
    ksort($parameters);
    
    // create the canonicalized query
    $canonicalized_query = array();
    foreach ($parameters as $param=>$value)
    {
        $param = str_replace('%7E', '~', rawurlencode($param));
        $value = str_replace('%7E', '~', rawurlencode($value));
        $canonicalized_query[] = $param.'='.$value;
    }
    $canonicalized_query = implode('&', $canonicalized_query);
    
    // create the string to sign
    $string_to_sign = $method."\n".$host."\n".$uri."\n".$canonicalized_query;
    
    // calculate HMAC with SHA256 and base64-encoding
    $signature = base64_encode(hash_hmac('sha256', $string_to_sign, $private_key, TRUE));
    
    // encode the signature for the request
    $signature = str_replace('%7E', '~', rawurlencode($signature));
    
    // create request
    $request = 'http://'.$host.$uri.'?'.$canonicalized_query.'&Signature='.$signature;
    
    return $request;
}
}
?>